	include		"calc.h"

	include		"doorsos.h"
	include		"hexlib.h"
	include		"macros.h"
	include		"prosit.h"
	include		"winlib.h"
	include		"keycodes.h"

	xdef    	_main
	xdef		_exit
	xdef		_comment

	xdef		prositdata@0000

WIN1_W			EQU	40
WIN1_X			EQU	SCREEN_WIDTH-WIN1_W-5
WIN1_Y			EQU	20

BUTTONS			EQU	4
BUT_X			EQU	2
BUT_Y			EQU	7+1
BUT_W			EQU	WIN1_W-4
BUT_H			EQU	9
BUT_S			EQU	BUT_H+1

WIN1_H			EQU	BUT_Y+1+4*BUT_S

_main:
	PROSIT_HEADER		;"Normal" DoorsOS shouldn't run this program.

	pea		w1gui(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	move.w		#WIN1_H,-(sp)			;Height
	move.w		#WIN1_W,-(sp)			;Width
	move.w		#WIN1_Y,-(sp)			;Y Position
	move.w		#WIN1_X,-(sp)			;X Position
	jsr		winlib::Create_Window		;d0.w = Window handle
	move.w		d0,WindowHandle1
	move.b		#0,2(sp)
	move.w		d0,(sp)
	jsr		winlib::Open_Window
	add.w		#16,sp

\sleep	jsr		Prosit::Sleep
	bra.s		\sleep


Event_Mousebutton:
	move.w		MouseButton,d0

	lsl.w		#1,d0
	lea		Programs(pc),a0
	move.w		0(a0,d0.w),d0

	pea		folder(pc)		;*Folder name
	pea		0(a0,d0.w)		;*File name
	jsr		Prosit::Get_File_Handle	;d5.w = File handle
	addq.l		#8,sp

	tst.w		d5
	beq.s		\done

	move.w		d5,-(sp)
	jsr		winlib::Load_Background_Image
	addq.l		#2,sp

\done	rts

_exit:
Event_Quit:
	move.w		#0,-(sp)
	jsr		winlib::Load_Background_Image
	addq.l		#2,sp
	move.w		WindowHandle1,-(sp)
	jsr		winlib::Close_Window
	jsr		winlib::Destroy_Window
	move.w		Prosit::CurrentProcessID,(sp)
	jsr		Prosit::Process_Terminate
	rts

;***********************************************************************

	EVEN

;Window #1 GUI structure, management part:
w1gui	dc.w	w1gfx-w1gui
	dc.w	1,1,7,6,w1bq-w1gui,-2
	dc.w	0,0,WIN1_W-1,6,0,-1
	dc.w	BUT_X,BUT_Y,BUT_X+BUT_W-1,BUT_Y+BUT_H-1,w1b1-w1gui,0
	dc.w	BUT_X,BUT_Y+BUT_S,BUT_X+BUT_W-1,BUT_Y+BUT_S+BUT_H-1,w1b2-w1gui,1
	dc.w	BUT_X,BUT_Y+2*BUT_S,BUT_X+BUT_W-1,BUT_Y+2*BUT_S+BUT_H-1,w1b3-w1gui,2
	dc.w	BUT_X,BUT_Y+3*BUT_S,BUT_X+BUT_W-1,BUT_Y+3*BUT_S+BUT_H-1,w1b4-w1gui,3
	dc.w	-1
;Window #1 GUI structure, graphical part
w1gfx	dc.w	R_BOX,0,0,WIN1_W,7,B_FILLED_BLACK
	dc.w	R_TEXT,8,1,F_INVERTED,0,wtitle1-w1gfx
	dc.w	R_BOX,0,0,WIN1_W,WIN1_H,B_TOP_BLACK+B_BOTTOM_BLACK+B_LEFT_BLACK+B_RIGHT_BLACK
w1b1	dc.w	R_TEXT_BUTTON,BUT_X,BUT_Y,BUT_W,BUT_H,2,2,F_NORMAL,0,wbut1-w1gfx
w1b2	dc.w	R_TEXT_BUTTON,BUT_X,BUT_Y+BUT_S,BUT_W,BUT_H,2,2,F_NORMAL,0,wbut2-w1gfx
w1b3	dc.w	R_TEXT_BUTTON,BUT_X,BUT_Y+2*BUT_S,BUT_W,BUT_H,2,2,F_NORMAL,0,wbut3-w1gfx
w1b4	dc.w	R_TEXT_BUTTON,BUT_X,BUT_Y+3*BUT_S,BUT_W,BUT_H,2,2,F_NORMAL,0,wbut4-w1gfx
w1bq	dc.w	R_GFX_BUTTON,1,1
			dc.l	clopen,clmask,clclose
	dc.w	-1
wtitle1	dc.b	"GFX",0
wbut1	dc.b	"Groovy",0
wbut2	dc.b	"Logo #1",0
wbut3	dc.b	"Logo #2",0
wbut4	dc.b	"Logo #3",0

clopen	dc.w	1,5
	dc.b	%11111110
	dc.b	%11010110
	dc.b	%11101110
	dc.b	%11010110
	dc.b	%11111110
clclose	dc.w	1,5
	dc.b	%10000010
	dc.b	%10101010
	dc.b	%10010010
	dc.b	%10101010
	dc.b	%10000010
clmask	dc.b	%11111110
	dc.b	%11111110
	dc.b	%11111110
	dc.b	%11111110
	dc.b	%11111110

folder		dc.b	"main",0
	EVEN
Programs:
	dc.w	file1-Programs
	dc.w	file2-Programs
	dc.w	file3-Programs
	dc.w	file4-Programs

file1	dc.b	"groovy",0
file2	dc.b	"logo1",0
file3	dc.b	"logo2",0
file4	dc.b	"logo3",0

	EVEN
prositdata@0000:
		dc.b	"pros"		;ID
		dc.w	400		;Stack size
		dc.w	0		;Message buffer size
P_Messages	dc.w	0		;No. of messages in message buffer
		dc.w	2		;No. of events
		dc.b	"moub"
		dc.l	Event_Mousebutton
		dc.b	"quit"
		dc.l	Event_Quit

_comment
	dc.b	"Prosit: Background",0

	BSS

WindowHandle1	dc.w	0

Window_Datareturn:
WKey		dc.w	0
MouseWindow	dc.w	0
MouseButton	dc.w	0
MouseX		dc.w	0
MouseY		dc.w	0

	CODE

	END
