	include		"calc.h"

	include		"doorsos.h"
	include		"macros.h"
	include		"hexlib.h"
	include		"prosit.h"
	include		"winlib.h"

	xdef		prosit_data@0000

	xdef    	_main
	xdef		_exit
	xdef		_comment

WINDOW_X		EQU	5
WINDOW_Y		EQU	5
WINDOW_WIDTH		EQU	97
WINDOW_HEIGHT		EQU	9
WINDOW_WORD_WIDTH	EQU	14
BLINK_TICKS		EQU	85

_main:
	PROSIT_HEADER		;"Normal" DoorsOS shouldn't run this program.

	pea		w1gui(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	move.w		#WINDOW_HEIGHT,-(sp)		;Height
	move.w		#WINDOW_WIDTH,-(sp)		;Width
	move.w		#WINDOW_Y,-(sp)			;Y Position
	move.w		#WINDOW_X,-(sp)			;X Position
	jsr		winlib::Create_Window		;d0.w = Window handle
	move.w		d0,WindowHandle
	move.b		#0,2(sp)
	move.w		d0,(sp)
	jsr		winlib::Open_Window
	add.w		#16,sp

	move.w		WindowHandle,d0
	doorsos::DEREF	d0,a0
	move.w		W_CONTENTS_HANDLE(a0),d0
	doorsos::DEREF	d0,a0
	add.l		#2*WINDOW_WORD_WIDTH+2,a0	;Plot area of window

	move.w		#4,d0
	lea		-2(a0),a1
\fill	or.b		#%00111110,(a1)
	add.w		#WINDOW_WORD_WIDTH,a1
	dbra.s		d0,\fill

	clr.l		OldTicks

;Real_main
	move.b		#$FF,OldKeys

	lea		doorsos::font_small,a1
	lea		48*6(a1),a1		;*0

Main_Loop:
	move.w		WindowHandle,-(sp)
	jsr		winlib::Refresh_Window
	addq.l		#2,sp

	BREAK_AND_COOPERATE

	move.l		Prosit::Ticks,d0

	move.l		d0,d3
	sub.l		OldTicks,d3
	cmp.l		#BLINK_TICKS,d3
	blt.s		\noblnk
	move.l		d0,OldTicks
	lea		blnkgfx(pc),a2
	lea		-1(a0),a3
	move.w		#4,d0
\fill	move.b		(a2)+,d3
	eor.b		d3,(a3)
	add.w		#WINDOW_WORD_WIDTH,a3
	dbra.s		d0,\fill

\noblnk	moveq		#0,d3
	moveq		#0,d4
	moveq		#0,d5
	moveq		#0,d6
	moveq		#0,d7

	moveq		#7,d2			;Number counter
\nloop	move.l		d0,d1
	and.l		#$0000000F,d1		;Only use one number
	lsr.l		#4,d0			;Shift away number from original
	cmp.b		#10,d1
	blt.s		\ok
	add.b		#65-58,d1		;Number is >9, add difference to "A"
\ok	mulu.w		#6,d1
	addq.w		#1,d1
	lea		0(a1,d1.w),a2		;*Number GFX

	move.b		(a2)+,d1	;Row #1
	lsr.b		#4,d1
	or.b		d1,d3
	ror.l		#4,d3

	move.b		(a2)+,d1	;Row #2
	lsr.b		#4,d1
	or.b		d1,d4
	ror.l		#4,d4

	move.b		(a2)+,d1	;Row #3
	lsr.b		#4,d1
	or.b		d1,d5
	ror.l		#4,d5

	move.b		(a2)+,d1	;Row #4
	lsr.b		#4,d1
	or.b		d1,d6
	ror.l		#4,d6

	move.b		(a2)+,d1	;Row #5
	lsr.b		#4,d1
	or.b		d1,d7
	ror.l		#4,d7

	dbra.s		d2,\nloop	;Next number

	move.l		d3,(a0)
	move.l		d4,WINDOW_WORD_WIDTH(a0)
	move.l		d5,2*WINDOW_WORD_WIDTH(a0)
	move.l		d6,3*WINDOW_WORD_WIDTH(a0)
	move.l		d7,4*WINDOW_WORD_WIDTH(a0)

	lea		status(pc),a2
	move.b		Prosit::ControlKeys,d0
 ifeq Calculator-TI92Plus
	and.b		#%00001111,d0
 endif
 ifeq Calculator-TI89
	and.b		#%11110000,d0
 endif
	cmp.b		OldKeys,d0
	beq		Main_Loop

	move.b		d0,OldKeys

	moveq		#0,d3
	moveq		#0,d4
	moveq		#0,d5
	moveq		#0,d6
	moveq		#0,d7

 ifeq Calculator-TI92Plus
	btst.b		#0,d0
 endif
 ifeq Calculator-TI89
	btst.b		#4,d0
 endif
	bne.s		\nosec
	move.b		(a2),d3
	move.b		1(a2),d4
	move.b		2(a2),d5
	move.b		3(a2),d6
	move.b		4(a2),d7

\nosec	lsl.l		#8,d3
	lsl.l		#8,d4
	lsl.l		#8,d5
	lsl.l		#8,d6
	lsl.l		#8,d7

 ifeq Calculator-TI92Plus
	btst.b		#1,d0
 endif
 ifeq Calculator-TI89
	btst.b		#6,d0
 endif
	bne.s		\nodia
	move.b		5(a2),d3
	move.b		6(a2),d4
	move.b		7(a2),d5
	move.b		8(a2),d6
	move.b		9(a2),d7

\nodia	lsl.l		#8,d3
	lsl.l		#8,d4
	lsl.l		#8,d5
	lsl.l		#8,d6
	lsl.l		#8,d7

 ifeq Calculator-TI92Plus
	btst.b		#2,d0
 endif
 ifeq Calculator-TI89
	btst.b		#5,d0
 endif
	bne.s		\noshft
	move.b		10(a2),d3
	move.b		11(a2),d4
	move.b		12(a2),d5
	move.b		13(a2),d6
	move.b		14(a2),d7

\noshft	lsl.l		#8,d3
	lsl.l		#8,d4
	lsl.l		#8,d5
	lsl.l		#8,d6
	lsl.l		#8,d7

 ifeq Calculator-TI92Plus
	btst.b		#3,d0
 endif
 ifeq Calculator-TI89
	btst.b		#7,d0
 endif
	bne.s		\nohand
	move.b		15(a2),d3
	move.b		16(a2),d4
	move.b		17(a2),d5
	move.b		18(a2),d6
	move.b		19(a2),d7

\nohand	move.l		d3,6(a0)
	move.l		d4,WINDOW_WORD_WIDTH+6(a0)
	move.l		d5,2*WINDOW_WORD_WIDTH+6(a0)
	move.l		d6,3*WINDOW_WORD_WIDTH+6(a0)
	move.l		d7,4*WINDOW_WORD_WIDTH+6(a0)

	bra		Main_Loop


Event_Mousebutton:
	movem.l		d1-d3,-(sp)

	moveq		#0,d1		;Default return

	move.w		MouseX,d2
	move.w		MouseX,d3

	cmp.w		#6,d2
	bgt.s		\done
	cmp.w		#2,d2
	blt.s		\done
	cmp.w		#6,d3
	bgt.s		\done
	cmp.w		#2,d3
	blt.s		\done
	move.w		#2,d1		;Return = DragWindow

\done	move.w		d1,MouseButton
	movem.l		(sp)+,d1-d3
	rts


_exit:
Event_Quit:
	move.w		WindowHandle,-(sp)
	jsr		winlib::Close_Window
	jsr		winlib::Destroy_Window
	move.w		Prosit::CurrentProcessID,(sp)
	jsr		Prosit::Process_Terminate


	EVEN
prosit_data@0000:
		dc.b	"slin"		;ID
		dc.w	400		;Stack size
		dc.w	0		;Message buffer size
P_Messages	dc.w	0		;No. of messages in message buffer
		dc.w	2		;No. of events
		dc.b	"moub"
		dc.l	Event_Mousebutton
		dc.b	"quit"
		dc.l	Event_Quit

;***********************************************************************

	EVEN
;Window GUI structure, management part
w1gui	dc.w	w1gfx-w1gui
	dc.w	1,1,7,WINDOW_HEIGHT-2,0,-1
	dc.w	-1
;Window GUI structure, graphical part
w1gfx	dc.w	R_BOX,0,0,WINDOW_WIDTH,WINDOW_HEIGHT,B_TOP_BLACK+B_BOTTOM_BLACK+B_LEFT_BLACK+B_RIGHT_BLACK
	dc.w	-1

OldKeys	dc.b	0

status	dc.b	%00110000
	dc.b	%00001000
	dc.b	%00010000
	dc.b	%00100000
	dc.b	%00111000

	dc.b	%00010000
	dc.b	%00111000
	dc.b	%01111100
	dc.b	%00111000
	dc.b	%00010000

	dc.b	%00010000
	dc.b	%00111000
	dc.b	%01111100
	dc.b	%00010000
	dc.b	%00010000

 ifeq Calculator-TI92Plus
	dc.b	%00111000
	dc.b	%00000100
	dc.b	%01110100
	dc.b	%01010100
	dc.b	%00111000
 endif
 ifeq Calculator-TI89
	dc.b	%00011000
	dc.b	%00100100
	dc.b	%00111100
	dc.b	%00100100
	dc.b	%00100100
 endif

blnkgfx	dc.b	%01111110
	dc.b	%00100100
	dc.b	%00011000
	dc.b	%00111100
	dc.b	%01111110

_comment
	dc.b	"Prosit: Status line",0

	BSS
OldTicks	dc.l	0

WindowHandle	dc.w	0

Window_Datareturn:
Key		dc.w	0
MouseWindow	dc.w	0
MouseButton	dc.w	0
MouseX		dc.w	0
MouseY		dc.w	0
	CODE

	END
