	include		"calc.h"

	include		"doorsos.h"
	include		"hexlib.h"
	include		"macros.h"

	include		"prosit.h"

	include		"keycodes.h"

	xdef		_library

	xdef		winlib@0000	;Init_Window_System
	xdef		winlib@0001	;Load_Background_Image
	xdef		winlib@0002	;Close_Window_System

	xdef		winlib@0003	;Create_Window
	xdef		winlib@0004	;Open_Window
	xdef		winlib@0005	;Move_Window
	xdef		winlib@0006	;Refresh_Window
	xdef		winlib@0007	;Move_Window_To_Front
	xdef		winlib@0008	;Close_Window
	xdef		winlib@0009	;Destroy_Window

	xdef		winlib@000A	;Clear
	xdef		winlib@000B	;SetClip
	xdef		winlib@000C	;VertLine
	xdef		winlib@000D	;HorizLine
	xdef		winlib@000E	;Box
	xdef		winlib@000F	;PlotGFX
	xdef		winlib@0010	;PlotText
	xdef		winlib@0011	;DrawStructure



W_NEXT			EQU	0
W_ID			EQU	W_NEXT+4
W_PRIORITY		EQU	W_ID+2

; These values are OK to read "from the outside":
W_FLAGS			EQU	W_PRIORITY+1
W_X_POS			EQU	W_FLAGS+1		;Window X position on LCD (pixels)
W_Y_POS			EQU	W_X_POS+2		;Window Y position on LCD (pixels)
W_WIDTH			EQU	W_Y_POS+2		;Window width in pixels
W_HEIGHT		EQU	W_WIDTH+2		;Window height in pixels
W_LEFT_CLIP		EQU	W_HEIGHT+2		;Left clip
W_TOP_CLIP		EQU	W_LEFT_CLIP+2		;Top clip
W_RIGHT_CLIP		EQU	W_TOP_CLIP+2		;Right clip
W_BOTTOM_CLIP		EQU	W_RIGHT_CLIP+2		;Bottom clip
W_WIDTH_IN_WORDS	EQU	W_BOTTOM_CLIP+2		;Window width in words (16 pixels)
W_CONTENTS_HANDLE	EQU	W_WIDTH_IN_WORDS+2	;Handle of window contents
W_OWNER			EQU	W_CONTENTS_HANDLE+2	;Window owner process ID
W_DATARETURN		EQU	W_OWNER+2		;Adress to window datareturn area

;These are *not* to be read from the outside!
W_STRUCTURE		EQU	W_DATARETURN+4		;Adress to structure
W_SHIFTED_HANDLE	EQU	W_STRUCTURE+4		;Handle of gfx to plot
W_MASK_HANDLE		EQU	W_SHIFTED_HANDLE+2	;Handle of refresh mask

;For shifting:
W_Y_OFFSET_IN_CONTENTS	EQU	W_MASK_HANDLE+2		;Offset within contents
W_VISIBLE_ROWS		EQU	W_Y_OFFSET_IN_CONTENTS+2;How many columns to shift per row
W_VISIBLE_COLUMNS	EQU	W_VISIBLE_ROWS+2	;How many rows to shift
W_ROWADD_CONTENTS	EQU	W_VISIBLE_COLUMNS+2	;RowAdd for contents/mask
W_ROWADD_LCD		EQU	W_ROWADD_CONTENTS+2	;RowAdd for the LCD
W_SHIFT_AMOUNT		EQU	W_ROWADD_LCD+2		;How much to shift each word
W_LCD_START_OFFSET	EQU	W_SHIFT_AMOUNT+2	;Where to start plotting on the LCD
W_X_OFFSET_IN_CONTENTS	EQU	W_LCD_START_OFFSET+2	;Offset within mask

W_SHIFTED_WIDTH		EQU	W_X_OFFSET_IN_CONTENTS+2

W_HEADER_SIZE		EQU	W_SHIFTED_WIDTH+2


W_DR_KEY		EQU	0
W_DR_MOUSE_WINDOW	EQU	W_DR_KEY+2
W_DR_MOUSE_BUTTON	EQU	W_DR_MOUSE_WINDOW+2
W_DR_MOUSE_X		EQU	W_DR_MOUSE_BUTTON+2
W_DR_MOUSE_Y		EQU	W_DR_MOUSE_X+2

F_NORMAL	EQU	0
F_DIMMED	EQU	1
F_BOLD		EQU	2
F_UNDERLINED	EQU	4
F_INVERTED	EQU	8
F_ITALIC	EQU	16

L_BLACK		EQU	2
L_WHITE		EQU	0
LB_COLOR	EQU	1
L_USES_PATTERN	EQU	1
LB_USES_PATTERN	EQU	0

B_TOP_WHITE		EQU	%0000000000000001
B_TOP_BLACK		EQU	%0000000000000101
B_TOP_PATTERN		EQU	%0000000000000011
B_BOTTOM_WHITE		EQU	%0000000000001000
B_BOTTOM_BLACK		EQU	%0000000000101000
B_BOTTOM_PATTERN	EQU	%0000000000011000
B_LEFT_WHITE		EQU	%0000000001000000
B_LEFT_BLACK		EQU	%0000000101000000
B_LEFT_PATTERN		EQU	%0000000011000000
B_RIGHT_WHITE		EQU	%0000001000000000
B_RIGHT_BLACK		EQU	%0000101000000000
B_RIGHT_PATTERN		EQU	%0000011000000000
B_FILLED_WHITE		EQU	%0001000000000000
B_FILLED_BLACK		EQU	%0101000000000000
B_FILLED_PATTERN	EQU	%0011000000000000

CLICK_OUTSIDE		EQU	-3

;SCREEN_WIDTH		EQU	240
;SCREEN_HEIGHT		EQU	128


	PROSIT_LOCK_HEADER	1

;---------------------------------------------------------------------
; Init_Window_System(void)
;
; Function: Initialize Window system
;---------------------------------------------------------------------
Init_Window_System:
winlib@0000:
	movem.l		a0-a2/d0-d2,-(sp)

	clr.w		WindowInFocus
	clr.l		WindowInFocus_Return

	clr.l		WindowList

	clr.w		bg_handle

;Allocate memory for background mask
	TOGGLE_PROSIT
	move.l		#30*128,-(sp)
	jsr		doorsos::HeapAlloc
	addq.l		#4,sp
	TOGGLE_PROSIT
	move.w		d0,bgm_handle
	doorsos::DEREF	d0,a0
	move.w		#30*128/4-1,d0
\clr	move.l		#$FFFFFFFF,(a0)+
	dbra.s		d0,\clr

	clr.b		msin
	clr.b		msout

;Initiate "mouse" thread
	pea		Mouse_Prositdata(pc)	;*PrositData
	pea		Mouse_Process(pc)	;*EntryPoint
	jsr		Prosit::Process_Fork
	move.w		d0,mid
	addq.l		#8,sp

;Initiate "mousebutton" thread
	pea		Mousebutton_Prositdata(pc)	;*PrositData
	pea		Mousebutton_Process(pc)		;*EntryPoint
	jsr		Prosit::Process_Fork
	move.w		d0,mbid
	addq.l		#8,sp

	bsr		Create_All_Masks
	bsr		Refresh_LCD

	movem.l		(sp)+,a0-a2/d0-d2
	rts

;---------------------------------------------------------------------
; Load_Background_Image(WORD filehandle)
;
; Function: Load a background image. The current image will be
;  replaced. If filehandle=0 the image will be blank.
;---------------------------------------------------------------------
Load_Background_Image:
winlib@0001:
	movem.l		a0-a2/a5/d0-d2/d5,-(sp)

	move.w		4+32(sp),d5
	bne.s		\load

	TOGGLE_PROSIT
	move.w		bg_handle,-(sp)
	beq.s		\nobg
	jsr		doorsos::HeapFree
\nobg	addq.w		#2,sp
	TOGGLE_PROSIT
	clr.w		bg_handle
	bra.s		\done

\load	move.w		bg_handle,d0
	bne.s		\exist
	TOGGLE_PROSIT
	move.l		#30*128,-(sp)
	jsr		doorsos::HeapAlloc
	addq.l		#4,sp
	TOGGLE_PROSIT
\exist	move.w		d0,bg_handle
	doorsos::DEREF	d0,a1			;*Background
	move.w		d5,-(sp)
	jsr		Prosit::Execute_File
	addq.l		#2,sp

\done	PROSIT_LOCK	1
	bsr		Refresh_Background
	PROSIT_UNLOCK	1
	movem.l		(sp)+,a0-a2/a5/d0-d2/d5
	rts

;---------------------------------------------------------------------
; Close_Window_System(void)
;
; Function: Close and de-allocate all remaining windows.
;---------------------------------------------------------------------
Close_Window_System:
winlib@0002:
	movem.l		a0-a2/d0-d2,-(sp)

	TOGGLE_PROSIT
	move.w		bg_handle,-(sp)
	beq.s		\nobg
	jsr		doorsos::HeapFree
\nobg	move.w		bgm_handle,(sp)
	jsr		doorsos::HeapFree
	addq.l		#2,sp
	TOGGLE_PROSIT

	move.w		mid,-(sp)
	jsr		Prosit::Process_Terminate
	move.w		mbid,(sp)
	jsr		Prosit::Process_Terminate
	addq.l		#2,sp

	movem.l		(sp)+,a0-a2/d0-d2
	rts

;---------------------------------------------------------------------
; Create_Window(WORD xpos, WORD ypos, WORD width, WORD height,
;  BYTE *Return, BYTE *Structure)
;
; Function: Create a window structure entry. The window's clip area
;  is automatically set to the entire window.
;
; <Return> is the adress of the program where winlib will return the
; following data:
;   00.w - Code of last key pressed, 0 if none.
;
; Return: d0.w = ID, 0 if failure
;         d1.w = Handle of window contents block
;---------------------------------------------------------------------
Create_Window:
winlib@0003:
	movem.l		a0-a3/d1-d2/d7,-(sp)

	TOGGLE_PROSIT
	move.l		#W_HEADER_SIZE,-(sp)
	jsr		doorsos::HeapAlloc
	addq.l		#4,sp
	TOGGLE_PROSIT

	move.w		d0,d7			;Store window handle
	beq		\fail

	doorsos::DEREF	d0,a3
	move.w		Prosit::CurrentProcessID,W_OWNER(a3)	;Owner
	move.w		4+7*4(sp),W_X_POS(a3)			;X Position
	move.w		4+7*4+2(sp),W_Y_POS(a3)			;Y position
	move.w		4+7*4+4(sp),d1				;Width
	move.w		d1,W_WIDTH(a3)
	move.w		4+7*4+6(sp),d2				;Height
	move.l		4+7*4+8(sp),a0				;*Return
	move.l		a0,W_DATARETURN(a3)
	clr.l		(a0)				;Clear last key pressed and mousebutton
	move.w		d2,W_HEIGHT(a3)
	move.l		4+7*4+12(sp),W_STRUCTURE(a3)

	clr.w		W_LEFT_CLIP(a3)		;Left clip = 0
	clr.w		W_TOP_CLIP(a3)		;Top clip = 0
	move.w		d1,W_RIGHT_CLIP(a3)
	sub.w		#1,W_RIGHT_CLIP(a3)	;Right clip = width-1
	move.w		d2,W_BOTTOM_CLIP(a3)
	sub.w		#1,W_BOTTOM_CLIP(a3)	;Bototm clip = height-1

	subq.w		#1,d1
	lsr.w		#4,d1			;Width/16
	addq.w		#1,d1			;Upper(Width/16)

	move.w		d1,d3			;Needed in two calculations
	addq.w		#2,d3			;Shifted data and Window mask needs one more column

	move.w		d1,W_WIDTH_IN_WORDS(a3)
	lsl.w		#1,d1			;2*Upper(Width/16)
	lsl.w		#1,d3			;Shifted data is both GFX and Mask

	mulu.w		d2,d1			;Memory for Contents
	addq.w		#1,d2		;Preliminary mask row
	mulu.w		d2,d3			;Memory for Shifted Data/Window mask

	TOGGLE_PROSIT
	move.l		d1,-(sp)
	jsr		doorsos::HeapAlloc
	move.w		d0,W_CONTENTS_HANDLE(a3)
	move.l		d3,(sp)
	jsr		doorsos::HeapAlloc
	move.w		d0,W_SHIFTED_HANDLE(a3)
	jsr		doorsos::HeapAlloc
	move.w		d0,W_MASK_HANDLE(a3)
	addq.l		#4,sp
	TOGGLE_PROSIT

	exg.w		d7,d0			;Restore window handle
;	move.w		W_CONTENTS_HANDLE(a3),d1

	move.l		W_STRUCTURE(a3),a0
	beq		\fail
	add.w		(a0),a0			;Skip over management part of structure :)
	move.l		a0,-(sp)
	move.w		d0,-(sp)
	bsr		Clear
	bsr		DrawStructure
	addq.l		#6,sp

\fail	movem.l		(sp)+,a0-a3/d1-d2/d7
	rts

;---------------------------------------------------------------------
; Open_Window(WORD ID, BYTE priority)
;
; Function: Put the window on the LCD. If the window is already open
;  it will be re-opened with the new priority.
;---------------------------------------------------------------------
Open_Window:
winlib@0004:
	PROSIT_LOCK	1

	movem.l		a0-a2/d0-d2/d6-d7,-(sp)

	move.w		4+8*4(sp),d6		;Window ID
	bsr		Make_Window_Focus	;The opened window ends up in the front right away.

	move.w		d6,d0
	doorsos::DEREF	d0,a0
	move.w		d6,W_ID(a0)		;List entry ID

	move.b		4+8*4+2(sp),-(sp)	;List entry priority
	move.l		a0,-(sp)		;*List entry
	move.l		#WindowList,-(sp)	;*List
	jsr		Prosit::List_Insert
	add.w		#10,sp

	bsr		Calculate_Window
	bsr		Create_All_Masks
	bsr		Shift_Window

	bsr		Internal_Refresh_Window

	movem.l		(sp)+,a0-a2/d0-d2/d6-d7

	PROSIT_UNLOCK	1
	rts

;---------------------------------------------------------------------
; Move_Window(WORD ID, WORD xpos, WORD ypos)
;
; Function: Move the window to (xpos,ypos).
;---------------------------------------------------------------------
Move_Window:
winlib@0005:
	PROSIT_LOCK	1

	movem.l		a0/d0/d6,-(sp)

	move.w		4+12(sp),d0
	move.w		d0,d6
	doorsos::DEREF	d0,a0
	move.w		4+14(sp),W_X_POS(a0)
	move.w		4+16(sp),W_Y_POS(a0)

	bsr		Calculate_Window
	bsr		Shift_Window

	bsr		Create_All_Masks
	bsr		Refresh_LCD

	movem.l		(sp)+,a0/d0/d6

	PROSIT_UNLOCK	1
	rts

;---------------------------------------------------------------------
; Refresh_Window(WORD ID)
;
; Function: Update the window's contents on the LCD.
;---------------------------------------------------------------------
Refresh_Window:
winlib@0006:
	PROSIT_LOCK	1

	movem.l		d6,-(sp)
	move.w		4+4(sp),d6

	bsr		Shift_Window
	bsr		Internal_Refresh_Window

	movem.l		(sp)+,d6

	PROSIT_UNLOCK	1
	rts

;****************************************************************
;* Internal Refresh_Window: Doesn't disable the mouse and takes *
;*  d6.w=window handle as input.                                *
;****************************************************************
Internal_Refresh_Window:
	movem.l		a0-a3/d0-d7,-(sp)

	doorsos::DEREF	d6,a0
	move.w		W_SHIFTED_HANDLE(a0),d0
	doorsos::DEREF	d0,a1				;*Shifted contents
	move.w		W_MASK_HANDLE(a0),d0
	doorsos::DEREF	d0,a2				;*Mask

	add.w		W_X_OFFSET_IN_CONTENTS(a0),a1	;*Shifted contents start
	add.w		W_SHIFTED_WIDTH(a0),a2		;*"Real" mask start

	move.l		#LCD_MEM,a3
	move.w		W_LCD_START_OFFSET(a0),d0
	lea		0(a3,d0.w),a3			;*LCD start adress

	move.w		W_ROWADD_CONTENTS(a0),d5
	move.w		W_ROWADD_LCD(a0),d4
	subq.w		#2,d4

	move.w		W_VISIBLE_ROWS(a0),d7
	subq.w		#1,d7

;Setup mouse refresh zone
	move.w		W_Y_POS(a0),d0
	move.w		d0,mUpper
	add.w		d7,d0
	move.w		d0,mLower
	move.w		W_X_POS(a0),d0
	move.w		d0,mLeft
	add.w		W_WIDTH(a0),d0
	move.w		d0,mRight
;Done

	bsr		Disable_Mouse

\rloop	move.w		W_VISIBLE_COLUMNS(a0),d6

\cloop	move.w		(a1)+,d0		;Window GFX
	move.w		(a2)+,d1		;Mask
	move.w		(a3),d2			;LCD GFX
	and.w		d1,d0
	not.w		d1
	and.w		d1,d2
	or.w		d2,d0
	move.w		d0,(a3)+
	dbra.s		d6,\cloop

	add.w		d5,a1
	add.w		d4,a3

	dbra.s		d7,\rloop

	bsr		Enable_Mouse

	movem.l		(sp)+,a0-a3/d0-d7
	rts

;---------------------------------------------------------------------
; Move_Window_To_Front(WORD ID)
;
; Function: Move the window to the front.
;---------------------------------------------------------------------
Move_Window_To_Front:
winlib@0007:
	movem.l		a0/d6-d7,-(sp)

	move.w		4+12(sp),d6		;Window handle

	cmp.w		WindowInFocus,d6
	beq.s		\done

	bsr		Make_Window_Focus

	PROSIT_LOCK	1
	move.w		d6,d0
	doorsos::DEREF	d0,a0

	move.b		W_PRIORITY(a0),-(sp)
;	move.w		d6,-(sp)
	move.l		a0,-(sp)
	move.l		#WindowList,-(sp)
	jsr		Prosit::List_Remove
	jsr		Prosit::List_Insert
	add.w		#10,sp

	bsr		Create_All_Masks
	bsr		Internal_Refresh_Window

	PROSIT_UNLOCK	1
\done	movem.l		(sp)+,a0/d6-d7
	rts

;---------------------------------------------------------------------
; Close_Window(WORD ID)
;
; Function: Remove the window from the LCD.
;---------------------------------------------------------------------
Close_Window:
winlib@0008:
	PROSIT_LOCK	1

	movem.l		a0-a2/d0-d2/d6-d7,-(sp)

	move.w		4+4*8(sp),d6		;Window handle
	move.w		d6,d0
	doorsos::DEREF	d0,a0

	cmp.w		WindowInFocus,d6
	bne.s		\nofoc
	move.l		W_NEXT(a0),a1
	exg.w		d6,d0
	move.w		W_ID(a1),d6
	bsr		Make_Window_Focus
	exg.w		d6,d0

\nofoc	move.l		a0,-(sp)
	move.l		#WindowList,-(sp)
	jsr		Prosit::List_Remove
	addq.l		#8,sp

	bsr		Create_All_Masks
	bsr		Refresh_LCD

\done	movem.l		(sp)+,a0-a2/d0-d2/d6-d7

	PROSIT_UNLOCK	1
	rts

;---------------------------------------------------------------------
; Destroy_Window(WORD ID)
;
; Function:Remove the window's structure from memory.
;---------------------------------------------------------------------
Destroy_Window:
winlib@0009:
	PROSIT_LOCK	1

	movem.l		a0-a3/d0-d2/d7,-(sp)

	move.w		4+8*4(sp),d0
	move.w		d0,d7
	doorsos::DEREF	d0,a3
	TOGGLE_PROSIT
	move.w		W_CONTENTS_HANDLE(a3),-(sp)
	jsr		doorsos::HeapFree
	move.w		W_SHIFTED_HANDLE(a3),(sp)
	jsr		doorsos::HeapFree
	move.w		W_MASK_HANDLE(a3),(sp)
	jsr		doorsos::HeapFree
	move.w		d7,(sp)
	jsr		doorsos::HeapFree
	addq.l		#2,sp
	TOGGLE_PROSIT

	movem.l		(sp)+,a0-a3/d0-d2/d7

	PROSIT_UNLOCK	1
	rts














;***************************************************************************

Make_Window_Focus:
	movem.l		a0/d6,-(sp)
	move.w		d6,WindowInFocus
	doorsos::DEREF	d6,a0
	move.l		W_DATARETURN(a0),WindowInFocus_Return
	movem.l		(sp)+,a0/d6
	rts

Refresh_Background:
	movem.l		a0-a2/d0-d3,-(sp)

	move.l		#bg_mask,a1
	move.l		#LCD_MEM,a2
	move.w		#30*128/4-1,d0

	bsr		Remove_Mouse

	move.w		bg_handle,d1
	bne.s		\image

;No image, just clear the screen.
\cpyc	move.l		(a1)+,d2	;BG mask
	move.l		(a2),d3		;Old LCD gfx
	not.l		d2
	and.l		d2,d3		;Mask Old LCD gfx
	move.l		d3,(a2)+	;Plot on LCD
	dbra.s		d0,\cpyc
	bra.s		\done

;Image, use whatever's loaded and mask and everything.
\image	doorsos::DEREF	d1,a0
\cpy	move.l		(a0)+,d1	;BG gfx
	move.l		(a1)+,d2	;BG mask
	move.l		(a2),d3		;Old LCD gfx
	and.l		d2,d1		;Mask BG gfx
	not.l		d2
	and.l		d2,d3		;Mask Old LCD gfx
	or.l		d3,d1		;Use both
	move.l		d1,(a2)+	;Plot on LCD
	dbra.s		d0,\cpy

\done	bsr		Enable_Mouse
	movem.l		(sp)+,a0-a2/d0-d3
	rts

;******************************************
;* Refresh the background and all windows *
;******************************************
Refresh_LCD:
	movem.l		a0-a2/d0-d3,-(sp)

	bsr		Refresh_Background

	move.l		WindowList,a0
	cmp.l		#0,a0
	beq		\done				;No windows to plot!

	move.l		a0,a1
\wloop	move.w		W_ID(a0),d6
	bsr		Internal_Refresh_Window
	move.l		W_NEXT(a0),a0
	cmp.l		a0,a1
	bne.s		\wloop

\done	movem.l		(sp)+,a0-a2/d0-d3
	rts

;***************************************************
;* Create masks for all windows and the background *
;***************************************************
Create_All_Masks:
	movem.l		a0-a5/d0-d7,-(sp)

	move.w		bgm_handle,d0
	doorsos::DEREF	d0,a0
	move.l		#bg_mask,a1
	move.w		#30*128/4-1,d0
\cpy	move.l		(a0)+,(a1)+
	dbra.s		d0,\cpy

	move.l		WindowList,a0
	cmp.l		#0,a0
	beq		\done				;No windows to make masks for!

	move.l		a0,a1

\wloop	move.w		W_MASK_HANDLE(a0),d0
	doorsos::DEREF	d0,a2				;*Mask
	move.l		a2,a3
	add.w		W_SHIFTED_WIDTH(a0),a3		;*Start of "real" mask
	add.w		W_X_OFFSET_IN_CONTENTS(a0),a2	;*Start of preliminary mask row

	move.l		#bg_mask,a5
	add.w		W_LCD_START_OFFSET(a0),a5	;*LCD start of window

	move.w		W_VISIBLE_ROWS(a0),d6
	subq.w		#1,d6
	move.w		W_VISIBLE_COLUMNS(a0),d4
	move.w		W_ROWADD_LCD(a0),d3
	subq.w		#2,d3

\rloop	move.l		a2,a4
	move.w		d4,d5

\cloop	move.w		(a4)+,d0	;Window mask
	and.w		(a5),d0		;Mask window mask with LCD mask
	move.w		d0,(a3)+	;Store window mask
	eor.w		d0,(a5)+	;Remove window mask from LCD mask and store new LCD mask
	dbra.s		d5,\cloop

	add.w		d3,a5			;Go to the next LCD row
	dbra.s		d6,\rloop		;Next row

	move.l		W_NEXT(a0),a0
	cmp.l		a0,a1
	bne		\wloop			;Next window

\done	movem.l		(sp)+,a0-a5/d0-d7
	rts

;**************************************************
;* Shift the GFX of the window with the handle d6 *
;**************************************************
Shift_Window:
	movem.l		a0-a3/d0-d7,-(sp)

	doorsos::DEREF	d6,a0				;*Window
	move.w		W_CONTENTS_HANDLE(a0),d0
	doorsos::DEREF	d0,a1				;*Contents
	move.w		W_Y_OFFSET_IN_CONTENTS(a0),d0
	add.w		W_Y_OFFSET_IN_CONTENTS(a0),a1

	move.w		W_SHIFTED_HANDLE(a0),d0
	doorsos::DEREF	d0,a2

	move.w		W_SHIFT_AMOUNT(a0),d5

	move.w		W_VISIBLE_ROWS(a0),d7
	subq.w		#1,d7

\rloop	moveq		#0,d0
	move.w		(a1)+,d0
	ror.l		d5,d0
	move.w		d0,(a2)+		;First word on row
	swap		d0

\rstart	move.w		W_WIDTH_IN_WORDS(a0),d6
	subq.w		#2,d6
	blt.s		\nxtrow

\cloop	moveq		#0,d1
	move.w		(a1)+,d1
	ror.l		d5,d1
	or.w		d0,d1
	move.w		d1,(a2)+
	swap		d1
	move.w		d1,d0
	dbra.s		d6,\cloop

\nxtrow	move.w		d0,(a2)+		;Last word on row

	dbra.s		d7,\rloop

\done	movem.l		(sp)+,a0-a3/d0-d7
	rts


;******************************************************************
;* Calculate shifting constants for the window with the handle d6 *
;******************************************************************
Calculate_Window:
	movem.l		a0/d0-d7,-(sp)

	doorsos::DEREF	d6,a0			;a0 = *Window

	move.w		W_HEIGHT(a0),d1		;No. of rows visible
	move.w		W_WIDTH_IN_WORDS(a0),d2	;No. of columns visible

	move.w		d2,d3
	addq.w		#1,d3
	lsl.w		#1,d3
	move.w		d3,W_SHIFTED_WIDTH(a0)

	moveq		#0,d0			;Default Y offset=0
	move.w		W_Y_POS(a0),d7
	bge.s		\ypos		;Y is positive, no Y offset
	sub.w		d7,d0		;Y is negative, increase Y offset...
	mulu.w		d2,d0		;...and multiply with the width.
	add.w		d7,d1		;Y is negative, decrease no. of visible rows.
	moveq		#0,d7
\ypos	move.w		d7,d6
	mulu.w		#15,d6		;LCD offset in Y
	add.w		d1,d7
	sub.w		#128,d7
	ble.s		\x		;Lower edge is on screen, continue to X calculations
	sub.w		d7,d1		;Lower edge is off screen, decrease no. of visible rows

\x	moveq		#0,d7			;Default Mask offset = 0
	move.w		W_X_POS(a0),d3
	asr.w		#4,d3
	bge.s		\xpos		;X is positive, no X offset
	add.w		d3,d2		;X is negative, decrease no. of visible columns
	sub.w		d3,d7		;X is negative, increase X offset
	moveq		#0,d3
\xpos	add.w		d3,d6		;LCD offset in X
	add.w		d2,d3
	sub.w		#14,d3
	ble.s		\done		;Right edge is on screen, continue
	sub.w		d3,d2		;Right edge is off screen, decrease no. of visible columns

\done	move.w		W_WIDTH_IN_WORDS(a0),d3	;RowAdd for original content - start with total width...
	sub.w		d2,d3			;...and subtract no. of visible columns.
	lsl.w		#1,d3			;Now RowAdd for original content is in bytes
	moveq		#15,d4			;RowAdd for LCD - start with total width...
	sub.w		d2,d4			;...and subtract no. of visible columns.
	lsl.w		#1,d4			;Now RowAdd for LCD is in bytes

	lsl.w		#1,d0			;Now Y Offset in original contents is in bytes
	lsl.w		#1,d7			;Now X Offset in original contents is in bytes
	lsl.w		#1,d6			;Now LCD offset is in bytes

	move.w		W_X_POS(a0),d5		;Get x position again...
	and.w		#%0000000000001111,d5	;The relevant bits

;Now d0 = Y Offset in original contents
;    d1 = No. of visible rows
;    d2 = No. of visible columns
;    d3 = RowAdd for original content
;    d4 = RowAdd for LCD
;    d5 = Shift amount
;    d6 = Offset on LCD
;    d7 = X Offset in original contents

	movem.w		d0-d7,W_Y_OFFSET_IN_CONTENTS(a0)

	move.w		W_WIDTH_IN_WORDS(a0),d0		;Width in words
	move.w		d0,d1				;Store it
	lsl.w		#4,d1				;One word = 16 pixels
	sub.w		W_WIDTH(a0),d1			;Overflow pixels
	moveq		#0,d3
	bset.w		d1,d3				;Set bit
	subq.w		#1,d3				;Set all bits lower than bit
	not.w		d3				;Leftmost pixel = LSB

	cmp.w		#1,d0
	beq.s		\one
;More than one word wide
	move.w		d3,d1
	or.l		#$FFFF0000,d1
	lsr.l		d5,d1
	move.w		d1,d2
	swap		d1
	ror.l		d5,d3
	swap		d3
	bra.s		\done2

;One word wide, just use the edge gfx
\one	ror.l		d5,d3
	move.w		d3,d1
	swap		d3

;Now d1 = Left edge of mask
;    d2 = Left part of right edge of mask
;    d3 = Right part of right edge of mask

\done2	move.w		W_MASK_HANDLE(a0),d0
	doorsos::DEREF	d0,a1

;Create preliminary mask row:
;----------------------------
	move.w		d1,(a1)+
	move.w		W_WIDTH_IN_WORDS(a0),d0
	subq.w		#2,d0
	blt.s		\end2
	beq.s		\end1
	subq.w		#1,d0
\cloop	move.w		#$FFFF,(a1)+
	dbra.s		d0,\cloop

\end1	move.w		d2,(a1)+
\end2	move.w		d3,(a1)+

	movem.l		(sp)+,a0/d0-d7
	rts

;***************************************************************************









BUFFER_WIDTH	EQU	34
BUFFER_HEIGHT	EQU	12

	include		"winlib_g.asm"














;***************************************************************************




	EVEN

Mouse_Prositdata:
		dc.b	"mous"		;ID
		dc.w	100		;Stack size
		dc.w	0		;Message buffer size
P_mMessages	dc.b	0		;No. of messages in message buffer
P_mStatus	dc.b	PS_NOT_RUNNING	;Process status
P_mEvent	dc.l	0
		dc.w	0		;No. of events

Mousebutton_Prositdata:
		dc.b	"moub"		;ID
		dc.w	400		;Stack size
		dc.w	0		;Message buffer size
P_mbMessages	dc.b	0		;No. of messages in message buffer
P_mbStatus	dc.b	PS_NOT_RUNNING	;Process status
P_mbEvent	dc.l	0
		dc.w	0		;No. of events

	EVEN













;**********************************************************************
;*                  KEY READER AND MOUSE BUTTON CODE                  *
;**********************************************************************
Mousebutton_Process:
	BREAK_AND_COOPERATE
	move.l		WindowInFocus_Return,a6
	cmp.l		#0,a6
	beq.s		Mousebutton_Process			;No windows on screen...

	tst.w		W_DR_MOUSE_BUTTON(a6)
	bne.s		\notrd
	move.w		Prosit::CurrentKey,(a6)

\notrd

	btst.b		#MOUSEBUTTON,Prosit::ControlKeys
	beq.s		\click
	clr.w		W_DR_MOUSE_BUTTON(a6)		;Mousebutton released
	bra.s		Mousebutton_Process

\click	move.l		WindowList,a0
	cmp.l		#0,a0
	beq		Mousebutton_Process	;List is empty, nothing to remove

	move.l		a0,a1

\loop	move.w		Prosit::MouseX,d2
	add.w		#POINTER_X_HOTSPOT,d2
	sub.w		W_X_POS(a0),d2
	blt.s		\next			;Window is right of mousepointer
	move.w		Prosit::MouseY,d3
	add.w		#POINTER_Y_HOTSPOT,d3
	sub.w		W_Y_POS(a0),d3
	blt.s		\next			;Window is below mousepointer
	cmp.w		W_WIDTH(a0),d2
	bgt.s		\next			;Window is left of mousepointer
	cmp.w		W_HEIGHT(a0),d3
	blt.s		\found			;Window is *not* above mousepointer => FOUND

\next	move.l		W_NEXT(a0),a0
	cmp.l		a0,a1
	bne.s		\loop

	bra		Mousebutton_Process

\found	move.w		W_ID(a0),d0
	cmp.w		WindowInFocus,d0
	beq.s		\infrnt
	move.w		d0,-(sp)
	bsr		Move_Window_To_Front
	addq.l		#2,sp

\infrnt	move.l		WindowInFocus_Return,a6
	move.l		W_STRUCTURE(a0),a2	;*Structure
	cmp.l		#0,a2
	beq		GUI_Outside		;Window has no structure, click goes to window
	move.l		a2,a3			;Store start of structure
	addq.l		#2,a2			;Skip first offset

;****************************
;*                          *
;* DEAL WITH THE WINDOW GUI *
;*                          *
;****************************
	moveq		#1,d7		;Status (1=inside, 0=outside)
GUI_Loop:
	tst.w		(a2)
	blt		GUI_Outside	;No item in the clicked area.

	cmp.w		(a2)+,d2
	bge.s		\okl		;We are to the right of X1, proceed
	add.w		#(6-1)*2,a2
	bra		GUI_Loop
\okl	cmp.w		(a2)+,d3
	bge.s		\okt		;We are below Y1, proceed
	add.w		#(6-2)*2,a2
	bra		GUI_Loop
\okt	cmp.w		(a2)+,d2
	ble.s		\okr		;We are to the left of X2, proceed
	add.w		#(6-3)*2,a2
	bra		GUI_Loop
\okr	cmp.w		(a2)+,d3
	ble.s		\okb		;We are above Y2, proceed
	add.w		#(6-4)*2,a2
	bra		GUI_Loop
\okb	move.w		(a2)+,d1	;Offset from start of GUI management section to current item
	move.w		(a2)+,d0	;Return value for item

	move.w		WindowInFocus,W_DR_MOUSE_WINDOW(a6)	;Window
	move.w		d0,W_DR_MOUSE_BUTTON(a6)		;Return value

	cmp.w		#-1,d0
	beq		GUI_Drag_Window		;System value: drag window

	lea		0(a3,d1.w),a4		;*Item data
	move.w		(a4)+,d1		;Item ID

	cmp.w		#R_TEXT_BUTTON,d1
	beq		GL_Text_Button
	cmp.w		#R_GFX_BUTTON,d1
	beq		GL_GFX_Button
;	cmp.w		#R_TEXT,d1
;	beq		GL_Text
;	cmp.w		#R_BOX,d1
;	beq		GL_Box
;	cmp.w		#R_SETCLIP,d1
;	beq		GL_SetClip
	bra		GUI_Loop		;Unrecognised item, exit

;***************
;* TEXT BUTTON *
;***************
GL_Text_Button:
	sub.w		#14,sp
	move.l		(a4)+,(sp)		;X, Y
	move.l		(a4)+,4(sp)		;Width, Height
	move.w		WindowInFocus,-(sp)	Window ID

	move.w		#GL_Text_Button_Inside-(GWMB1+2),GWMB1+2
	move.w		#GL_Text_Button_Outside-(GWMB2+2),GWMB2+2
	move.w		#GL_Text_Button_Release-(GWMB3+2),GWMB3+2
GL_Text_Button_Inside:
	move.w		#%1010000000000000,14(sp)	;Pattern for right line
	move.w		#%0110000000000000,12(sp)	;Pattern for bottom line
	move.w		#B_TOP_BLACK+B_LEFT_BLACK+B_BOTTOM_PATTERN+B_RIGHT_PATTERN,10(sp)
	bra		GL_Text_Button_Plot
GL_Text_Button_Outside:
	move.w		#%0110000000000000,14(sp)	;Pattern for left line
	move.w		#%1010000000000000,12(sp)	;Pattern for top line
	move.w		#B_TOP_PATTERN+B_LEFT_PATTERN+B_BOTTOM_BLACK+B_RIGHT_BLACK,10(sp)
GL_Text_Button_Plot:
	bsr		Box
	bsr		Refresh_Window
	bra		GUI_WaitMB
GL_Text_Button_Release:
	move.w		#%0110000000000000,14(sp)	;Pattern for right line
	move.w		#%1010000000000000,12(sp)	;Pattern for bottom line
	move.w		#B_TOP_PATTERN+B_LEFT_PATTERN+B_BOTTOM_BLACK+B_RIGHT_BLACK,10(sp)
	bsr		Box
	bsr		Refresh_Window
	add.w		#2*8,sp
	bra		Mousebutton_Process

;**************
;* GFX BUTTON *
;**************
GL_GFX_Button:
	sub.w		#12,sp
	move.l		(a4)+,(sp)		;X, Y
	move.l		4(a4),8(sp)		;*mask
	move.w		WindowInFocus,-(sp)	Window ID

	move.w		#GL_GFX_Button_Inside-(GWMB1+2),GWMB1+2
	move.w		#GL_GFX_Button_Outside-(GWMB2+2),GWMB2+2
	move.w		#GL_GFX_Button_Release-(GWMB3+2),GWMB3+2
GL_GFX_Button_Inside:
	move.l		8(a4),2+4(sp)		;*gfx
	bra		GL_GFX_Button_Plot
GL_GFX_Button_Outside:
	move.l		(a4),2+4(sp)		;*gfx
GL_GFX_Button_Plot:
	bsr		PlotGFX
	bsr		Refresh_Window
	bra		GUI_WaitMB
GL_GFX_Button_Release:
	move.l		(a4),2+4(sp)		;*gfx
	bsr		PlotGFX
	bsr		Refresh_Window
	add.w		#3*4+2,sp
	bra		Mousebutton_Process

;*
;* WE ARE PRESSING AN AREA, DEAL WITH IT BEFORE PASSING VALUE TO PROCESS...
;* (STILL TO IMPLEMENT).
;*
;	move.w		WindowInFocus,W_DR_MOUSE_WINDOW(a6)
;	move.w		d0,W_DR_MOUSE_BUTTON(a6)
;	move.w		d2,W_DR_MOUSE_X(a6)
;	move.w		d3,W_DR_MOUSE_Y(a6)
;	TRIGGER_EVENT	W_OWNER(a1),#"moub"

GUI_WaitMB:
	btst.b		#MOUSEBUTTON,Prosit::ControlKeys
	beq		GWMB_Check
GWMP_Release:
	tst.w		d7
	beq		GWMB3
	cmp.w		#-2,d0
	bne.s		\norm
	TRIGGER_EVENT	W_OWNER(a0),#"quit"		;Trigger Quit event
	bra		GWMB3
\norm	TRIGGER_EVENT	W_OWNER(a0),#"moub"		;Trigger Mousebutton event
GWMB3:	bra		#$1234

GWMB_Check:
	BREAK_AND_COOPERATE
	move.w		Prosit::MouseX,d2
	add.w		#POINTER_X_HOTSPOT,d2
	sub.w		W_X_POS(a0),d2
	move.w		Prosit::MouseY,d3
	add.w		#POINTER_Y_HOTSPOT,d3
	sub.w		W_Y_POS(a0),d3

	cmp.w		-12(a2),d2	;x < x1?
	blt		GWMB_Out
	cmp.w		-10(a2),d3	;y < y1?
	blt		GWMB_Out
	cmp.w		-8(a2),d2	;x > x2?
	bgt		GWMB_Out
	cmp.w		-6(a2),d3	;y > y2?
	bgt		GWMB_Out
GWMB_In:
	tst.w		d7
	bne		GUI_WaitMB
	moveq		#1,d7
GWMB1:	bra		#$1234
GWMB_Out:
	tst.w		d7
	beq		GUI_WaitMB
	moveq		#0,d7
GWMB2:	bra		#$1234


GUI_Outside:
;	move.w		WindowInFocus,W_DR_MOUSE_WINDOW(a6)
;	move.w		#0,W_DR_MOUSE_BUTTON(a6)
;	move.w		d2,W_DR_MOUSE_X(a6)
;	move.w		d3,W_DR_MOUSE_Y(a6)
;	TRIGGER_EVENT	W_OWNER(a0),#"moub"
\relese	move.w		Prosit::MouseX,d2
	add.w		#POINTER_X_HOTSPOT,d2
	sub.w		W_X_POS(a0),d2
	move.w		Prosit::MouseY,d3
	add.w		#POINTER_Y_HOTSPOT,d3
	sub.w		W_Y_POS(a0),d3
	move.w		d2,W_DR_MOUSE_X(a6)
	move.w		d3,W_DR_MOUSE_Y(a6)
	tst.w		W_DR_MOUSE_BUTTON(a6)
	bne.s		\relese
\waitmb	btst.b		#MOUSEBUTTON,Prosit::ControlKeys
	beq.s		\waitmb
	clr.w		W_DR_MOUSE_BUTTON(a6)
	bra		Mousebutton_Process

GUI_Drag_Window:
	sub.w		#POINTER_X_HOTSPOT,d2
	sub.w		#POINTER_Y_HOTSPOT,d3
	moveq		#0,d6
\holdl	BREAK_AND_COOPERATE
	btst.b		#MOUSEBUTTON,Prosit::ControlKeys
	bne		Mousebutton_Process
	move.w		Prosit::MouseX,d5
	sub.w		d2,d5
	swap		d5
	move.w		Prosit::MouseY,d5
	sub.w		d3,d5
	cmp.l		d5,d6
	beq.s		\holdl
	move.l		d5,d6
	move.l		d5,-(sp)
	move.w		WindowInFocus,-(sp)
	bsr		Move_Window
	addq.l		#6,sp
	bra		\holdl

;**********************************************************************
;*                             MOUSE CODE                             *
;**********************************************************************

POINTER_HEIGHT		EQU	8
POINTER_WIDTH		EQU	6
POINTER_X_HOTSPOT	EQU	1
POINTER_Y_HOTSPOT	EQU	1
SPEED_DELAY		EQU	1



Disable_Mouse:
	move.b		#1,msin	;Signal "disable with saving"
\wait2	BREAK_AND_COOPERATE
	tst.b		msout	;Wait for mouse pointer to signal "waiting"
	beq.s		\wait2
	rts

Remove_Mouse:
	move.b		#2,msin	;Signal "disable without saving"
\wait2	BREAK_AND_COOPERATE
	tst.b		msout	;Wait for mouse pointer to signal "waiting"
	beq.s		\wait2
	rts

Enable_Mouse:
	clr.b		msin
\wait2	BREAK_AND_COOPERATE
	tst.b		msout	;Wait for mouse pointer to signal "running"
	bne.s		\wait2
	rts

Mouse_Plot:
\move	move.w		d3,d1
	bge.s		\ypos
	moveq		#0,d1
	clr.w		Prosit::MouseY
	bra.s		\yok
\ypos	cmp.w		#SCREEN_HEIGHT-2-POINTER_Y_HOTSPOT,d1
	ble.s		\yok
	moveq.w		#SCREEN_HEIGHT-2-POINTER_Y_HOTSPOT,d1
	move.w		#SCREEN_HEIGHT-2-POINTER_Y_HOTSPOT,Prosit::MouseY
\yok	move.w		d2,d0
	bge.s		\xpos
	moveq		#0,d0
	clr.w		Prosit::MouseX
	bra.s		\xok
\xpos	cmp.w		#SCREEN_WIDTH-POINTER_WIDTH,d0
	ble.s		\xok
	move.w		#SCREEN_WIDTH-POINTER_WIDTH,d0
	move.w		#SCREEN_WIDTH-POINTER_WIDTH,Prosit::MouseX

\xok	move.l		#LCD_MEM,a3
	move.w		d1,d4
	lsl.w		#5,d4
	sub.w		d1,d4
	sub.w		d1,d4
	move.w		d0,d5
	lsr.w		#4,d5
	lsl.w		#1,d5			;Make sure we get an even adress
	add.w		d5,d4
	lea		0(a3,d4.w),a3		;Adress in LCD memory to start plotting at

	move.b		d0,d6
	and.b		#%00001111,d6		;Shift amount
	move.l		a1,a2			;LCD buffer data
	move.l		a0,a4			;GFX and Mask data
	move.l		a3,a5			;Store LCD adress

	move.w		#128-POINTER_HEIGHT,d7
	sub.w		d1,d7
	blt.s		\ok
	moveq		#0,d7
\ok	add.w		#POINTER_HEIGHT-1,d7	;Row counter
	move.w		d7,mRows
\ploop	move.l		(a4)+,d2		;Read Mask data
	lsr.l		d6,d2			;Shift Mask data
	move.l		(a4)+,d3		;Read GFX data
	lsr.l		d6,d3			;Shift GFX data
	move.l		(a5),d4			;Read LCD data
	and.l		d4,d2			;Create EOR mask...
	eor.l		d3,d2			;Create EOR mask...
	move.l		d2,(a2)+		;Store EOR data
	eor.l		d2,(a5)			;Plot
	add.w		#30,a5			;Next row
	dbra.s		d7,\ploop

	rts

Mouse_Remove:
	move.l		a1,a2			;LCD buffer
	move.w		mRows,d7		;Row counter
\rloop	move.l		(a2)+,d6
	eor.l		d6,(a3)
	add.w		#30,a3
	dbra.s		d7,\rloop
	rts



Mouse_Process:
	move.w		#$77,d2
	move.w		#$3F,d3
	move.l		#$0077003F,Prosit::MouseX
	lea		gfx(pc),a0
	move.l		#mbuffer,a1

\plot	bsr		Mouse_Plot
\noplot	clr.b		msout

\check1	BREAK_AND_COOPERATE
	move.w		Prosit::MouseX,d2
	move.w		Prosit::MouseY,d3

	tst.b		msin
	bne.s		\remove

	cmp.w		d2,d0
	bne.s		\move
	cmp.w		d3,d1
	beq.s		\check1

\move	bsr		Mouse_Remove
	bra.s		\plot


;"Remove" or "Disable" signalled from winlib.
\remove	cmp.b		#2,msin
	beq.s		\rem

	moveq		#0,d5		;Default = don't refresh

	cmp.w		mRight,d0
	bgt.s		\norefr
	cmp.w		mLower,d1
	bgt.s		\norefr
	sub.w		#POINTER_WIDTH,mLeft
	cmp.w		mLeft,d0
	ble.s		\norefr
	sub.w		#POINTER_HEIGHT,mUpper
	cmp.w		mUpper,d1
	ble.s		\norefr

\rem	moveq		#1,d5
	bsr		Mouse_Remove

\norefr	move.b		#1,msout
\wait1	BREAK_AND_COOPERATE
	tst.b		msin
	bne.s		\wait1

	tst.w		d5
	beq		\noplot
	bra		\plot

;***********************************************************************

	EVEN

gfx	dc.l	%11100000000000000000000000000000,%00000000000000000000000000000000
	dc.l	%11110000000000000000000000000000,%01000000000000000000000000000000
	dc.l	%11111000000000000000000000000000,%01100000000000000000000000000000
	dc.l	%11111100000000000000000000000000,%01010000000000000000000000000000
	dc.l	%11111100000000000000000000000000,%01001000000000000000000000000000
	dc.l	%11111100000000000000000000000000,%01001000000000000000000000000000
	dc.l	%11111100000000000000000000000000,%00111000000000000000000000000000
	dc.l	%01111100000000000000000000000000,%00000000000000000000000000000000

	BSS
WindowInFocus		dc.w	0
WindowInFocus_Return	dc.l	0

WindowList		dc.l	0

bg_handle		dc.w	0
bgm_handle		dc.w	0
bg_mask			ds.b	3840

mbid			dc.w	0

mid			dc.w	0
mbuffer			ds.l	POINTER_HEIGHT
mRows			dc.w	0
mLeft			dc.w	0
mRight			dc.w	0
mUpper			dc.w	0
mLower			dc.w	0
msin			dc.b	0
msout			dc.b	0

buffer		ds.b	4+BUFFER_WIDTH*BUFFER_HEIGHT
buffer_m	ds.b	BUFFER_WIDTH*BUFFER_HEIGHT

	END
