;These are offsets from the start adress of a window structure. Use
;with caution!

W_FLAGS			EQU	LIST_HEADER_SIZE-1
W_X_POS			EQU	W_FLAGS+1		;Window X position on LCD (pixels)
W_Y_POS			EQU	W_X_POS+2		;Window Y position on LCD (pixels)
W_WIDTH			EQU	W_Y_POS+2		;Window width in pixels
W_HEIGHT		EQU	W_WIDTH+2		;Window height in pixels
W_LEFT_CLIP		EQU	W_HEIGHT+2		;Left clip
W_TOP_CLIP		EQU	W_LEFT_CLIP+2		;Top clip
W_RIGHT_CLIP		EQU	W_TOP_CLIP+2		;Right clip
W_BOTTOM_CLIP		EQU	W_RIGHT_CLIP+2		;Bottom clip
W_WIDTH_IN_WORDS	EQU	W_BOTTOM_CLIP+2		;Window width in words (16 pixels)
W_CONTENTS_HANDLE	EQU	W_WIDTH_IN_WORDS+2	;Handle of window contents
W_OWNER			EQU	W_CONTENTS_HANDLE+2	;Window owner process ID
W_DATARETURN		EQU	W_OWNER+2		;Adress of window datareturn area

W_DR_KEY		EQU	0
W_DR_MOUSE_WINDOW	EQU	W_DR_KEY+2
W_DR_MOUSE_BUTTON	EQU	W_DR_MOUSE_WINDOW+2
W_DR_MOUSE_X		EQU	W_DR_MOUSE_BUTTON+2
W_DR_MOUSE_Y		EQU	W_DR_MOUSE_X+2

L_BLACK		EQU	2
L_WHITE		EQU	0
L_USES_PATTERN	EQU	1

B_TOP_WHITE		EQU	%0000000000000001
B_TOP_BLACK		EQU	%0000000000000101
B_TOP_PATTERN		EQU	%0000000000000011
B_BOTTOM_WHITE		EQU	%0000000000001000
B_BOTTOM_BLACK		EQU	%0000000000101000
B_BOTTOM_PATTERN	EQU	%0000000000011000
B_LEFT_WHITE		EQU	%0000000001000000
B_LEFT_BLACK		EQU	%0000000101000000
B_LEFT_PATTERN		EQU	%0000000011000000
B_RIGHT_WHITE		EQU	%0000001000000000
B_RIGHT_BLACK		EQU	%0000101000000000
B_RIGHT_PATTERN		EQU	%0000011000000000
B_FILLED_WHITE		EQU	%0001000000000000
B_FILLED_BLACK		EQU	%0101000000000000
B_FILLED_PATTERN	EQU	%0011000000000000

B_BLACK_FRAME	EQU	1+0
B_WHITE_FRAME	EQU	1+2
B_NO_FILL	EQU	0
B_BLACK_FILL	EQU	4+0
B_WHITE_FILL	EQU	4+8

;Buttons
R_TEXT_BUTTON	EQU	1	;X, Y, Width, Height, XText, YText, Font, Flags, _Text
R_GFX_BUTTON	EQU	2	;X, Y, _gfx, _mask
;Graphics
R_TEXT		EQU	128	;X, Y, Flags, Font, _Text
R_BOX		EQU	129	;Same as winlib::Box except the ID.
;Window system specific stuff
R_SETCLIP	EQU	192	;X1, Y1, X2, Y2

;***************************
;*                         *
;* WINDOW SYSTEM FUNCTIONS *
;*                         *
;***************************

;---------------------------------------------------------------------
; Init_Window_System(void)
;
; Function: Initialize Window system
;---------------------------------------------------------------------
winlib::Init_Window_System	equ	winlib@0000

;---------------------------------------------------------------------
; Load_Background_Image(WORD filehandle)
;
; Function: Load a background image. The current image will be
;  replaced. If filehandle=0 the image will be blank.
;---------------------------------------------------------------------
winlib::Load_Background_Image	equ	winlib@0001

;---------------------------------------------------------------------
; Close_Window_System(void)
;
; Function: Close and de-allocate all remaining windows.
;---------------------------------------------------------------------
winlib::Close_Window_System	equ	winlib@0002

;---------------------------------------------------------------------
; Create_Window(WORD xpos, WORD ypos, WORD width, WORD height,
;  BYTE *Return, BYTE *Structure)
;
; Function: Create a window structure entry. The window's clip area
;  is automatically set to the entire window.
;
; <Return> is the adress of the program where winlib will return the
; following data:
;   00.w - Code of last key pressed, 0 if none.
;
; Return: d0.w = ID, 0 if failure
;         d1.w = Handle of window contents block
;---------------------------------------------------------------------
winlib::Create_Window		equ	winlib@0003

;---------------------------------------------------------------------
; Open_Window(WORD ID, BYTE priority)
;
; Function: Put the window on the LCD. If the window is already open
;  it will be re-opened with the new priority.
;---------------------------------------------------------------------
winlib::Open_Window		equ	winlib@0004

;---------------------------------------------------------------------
; Move_Window(WORD ID, WORD xpos, WORD ypos)
;
; Function: Move the window to (xpos,ypos).
;---------------------------------------------------------------------
winlib::Move_Window		equ	winlib@0005

;---------------------------------------------------------------------
; Refresh_Window(WORD ID)
;
; Function: Update the window's contents on the LCD.
;---------------------------------------------------------------------
winlib::Refresh_Window		equ	winlib@0006

;---------------------------------------------------------------------
; Move_Window_To_Front(WORD ID)
;
; Function: Move the window to the front.
;---------------------------------------------------------------------
winlib::Move_Window_To_Front	equ	winlib@0007

;---------------------------------------------------------------------
; Close_Window(WORD ID)
;
; Function: Remove the window from the LCD.
;---------------------------------------------------------------------
winlib::Close_Window		equ	winlib@0008

;---------------------------------------------------------------------
; Destroy_Window(WORD ID)
;
; Function:Remove the window's structure from memory.
;---------------------------------------------------------------------
winlib::Destroy_Window		equ	winlib@0009



;*****************************
;*                           *
;* WINDOW GRAPHICS FUNCTIONS *
;*                           *
;*****************************

;---------------------------------------------------------------------
; Clear(WORD ID)
;
; Function: Clear the window contents block.
;---------------------------------------------------------------------
winlib::Clear			equ	winlib@000A

;---------------------------------------------------------------------
; SetClip(WORD ID, BYTE *clip)
;
; Function: Set window <ID> to use the clip area <clip>.
;---------------------------------------------------------------------
winlib::SetClip			equ	winlib@000B

;---------------------------------------------------------------------
; VertLine(WORD ID, WORD x, WORD y1, WORD y2, WORD flags,
;  [WORD pattern])
;
; Function: Draw a line from (x1,y) to (x2,y).
;
; Flags: Bit 0 = Pattern/no pattern
;        Bit 1 = Color (if no pattern)
;---------------------------------------------------------------------
winlib::VertLine		equ	winlib@000C

;---------------------------------------------------------------------
; HorizLine(WORD ID, WORD x, WORD y1, WORD y2, WORD flags,
;  [WORD pattern])
;
; Function: Draw a line from (x,y1) to (x,y2).
;
; Flags: Bit 0 = Pattern/no pattern
;        Bit 1 = Color (if no pattern)
;---------------------------------------------------------------------
winlib::HorizLine		equ	winlib@000D

;---------------------------------------------------------------------
; Box(WORD ID, WORD x, WORD y, WORD width, WORD height, WORD flags,
;  [WORD pattern], [WORD pattern], [WORD pattern], [WORD pattern],
;  [BYTE *gfx, BYTE *mask]
;
; Function: Draw a <width,height>-sized box at (x, y).
; Flags:  Bit 0 = Top frame / no top frame
;         Bit 1 = Top pattern / no top pattern
;         Bit 2 = Top color (if no pattern)
;         Bit 3 = Bottom frame / no top frame
;         Bit 4 = Bottom pattern / no top pattern
;         Bit 5 = Bottom color (if no pattern)
;         Bit 6 = Left frame / no top frame
;         Bit 7 = Left pattern / no top pattern
;         Bit 8 = Left color (if no pattern)
;         Bit 9 = Right frame / no top frame
;        Bit 10 = Right pattern / no top pattern
;        Bit 11 = Right color (if no pattern)
;        Bit 12 = Filled / not filled
;        Bit 13 = Fill pattern / no fill pattern
;        Bit 14 = Fill color (if no pattern)
;                 Choices for stretch/center/tile?
;---------------------------------------------------------------------
winlib::Box			equ	winlib@000E

;---------------------------------------------------------------------
; PlotGFX(WORD ID, WORD x, WORD y, BYTE *gfx)
;
; Function: Plot <gfx> at (x,y) in window <ID>, using the window's
;  current clip area. The format for gfx is described in the docs.
;---------------------------------------------------------------------
winlib::PlotGFX			equ	winlib@000F

;---------------------------------------------------------------------
; PlotText(WORD ID, WORD x, WORD y, WORD flags, WORD font,
;  BYTE *string)
;
; Function: Draw the text <string> at (x,y) in window <ID> using
;  flags <flags>, font <font> and the window's current cliparea.
;
; Flagbits:
;  0 = Dimmed text on/off
;  1 = Bold text on/off
;  2 = Underlined text on/off
;  3 = Inverted text on/off
;  4 = Italic text on/off
;
; Fonts:
;   0 = TIOS small font
;   1 = TIOS medium font
;   2 = TIOS large font
;  3+ = User-defined fonts
;---------------------------------------------------------------------
F_NORMAL	EQU	0
F_DIMMED	EQU	1
F_BOLD		EQU	2
F_UNDERLINED	EQU	4
F_INVERTED	EQU	8
F_ITALIC	EQU	16
winlib::PlotText		equ	winlib@0010

;---------------------------------------------------------------------
; DrawStructure(WORD ID, BYTE *structure)
;
; Function: Draw <structure> into window.
;---------------------------------------------------------------------
winlib::DrawStructure		equ	winlib@0011
