	include		"calc.h"

	xdef    	_main
	xdef		_exit
	xdef		_comment

	include		"doorsos.h"
	include		"macros.h"
	include		"hexlib.h"
	include		"userlib.h"
	include		"graphlib.h"

_main:
	jsr		graphlib::clr_scr

;Draw a line on the LCD
;DrawClipLine(RECT *Line, *Port region, BYTE Attribute, BYTE *Dup_Scr)
	jsr		doorsos::PortRestore
	move.l		#LCD_MEM,-(sp)
	move.w		#$0101,-(sp)		;Attributes
	pea		clip(pc)		;*Port region
	pea		line(pc)		;*Line
	jsr		doorsos::DrawClipLine
	add.w		#14,sp

	jsr		userlib::idle_loop	

	jsr		doorsos::PortRestore

	move.w		#A_NORMAL,-(sp)		;Attributes
	move.w		#126,-(sp)		;y2
	move.w		#238,-(sp)		;x2
	move.w		#1,-(sp)		;y1
	move.w		#1,-(sp)		;x1
	jsr		doorsos::DrawLine
	add.w		#10,sp

	jsr		userlib::idle_loop	

;Draw a filled triangle on the LCD
	move.w		#127,-(sp)
	move.w		#239,-(sp)
	move.l		#LCD_MEM,-(sp)
	jsr		doorsos::PortSet
	addq.l		#8,sp

	move.w		#$0003,-(sp)
	jsr		doorsos::SetCurAttr
	addq.l		#2,sp

	move.w		#$0006,-(sp)		;Attributes
	pea		clip(pc)		;*Clipping region
	move.w		#120,-(sp)		;cy
	move.w		#100,-(sp)		;cx
	move.w		#43,-(sp)		;by
	move.w		#15,-(sp)		;bx
	move.w		#10,-(sp)		;ay
	move.w		#223,-(sp)		;ax
	jsr		doorsos::FillTriangle
	add.w		#18,sp

	jsr		userlib::idle_loop	

	jsr		doorsos::PortRestore

;Open window #1
	move.w		#WF_SYS_ALLOC+WF_DUP_SCR,-(a7)	;Flags
	pea		dim1(pc)				;*Dimensions
	move.l		#win1,-(sp)				;*Window
	jsr		doorsos::WinOpen
	jsr		doorsos::WinActivate
	jsr		doorsos::WinClr
	add.w		#10,sp
;Draw title box
	move.w		#A_NORMAL,-(sp)
	pea		box1(pc)
	move.l		#win1,-(sp)
	jsr		doorsos::WinFill
	add.w		#10,sp
;Set window font
	move.w		#F_SMALL,-(sp)
	move.l		#win1,-(sp)
	jsr		doorsos::WinFont
	add.w		#6,sp
;Set window attributes
	move.w		#A_REVERSE,-(sp)
	move.l		#win1,-(sp)
	jsr		doorsos::WinAttr
	addq.l		#6,sp
;Draw title string
	pea		title1(pc)		;*String
	move.w		#0,-(sp)		;Y
	move.w		#7,-(sp)		;X
	move.l		#win1,-(sp)		;*Window
	jsr		doorsos::WinStrXY
	add.w		#12,sp


;Open window #2
	move.w		#WF_SYS_ALLOC+WF_DUP_SCR,-(a7)	;Flags
	pea		dim2(pc)				;*Dimensions
	move.l		#win2,-(sp)				;*Window
	jsr		doorsos::WinOpen
	jsr		doorsos::WinActivate
	jsr		doorsos::WinClr
	add.w		#10,sp
;Draw title box
	move.w		#A_NORMAL,-(sp)
	pea		box2(pc)
	move.l		#win2,-(sp)
	jsr		doorsos::WinFill
	add.w		#10,sp
;Set window font
	move.w		#F_SMALL,-(sp)
	move.l		#win2,-(sp)
	jsr		doorsos::WinFont
	add.w		#6,sp
;Set window attributes
	move.w		#A_REVERSE,-(sp)
	move.l		#win2,-(sp)
	jsr		doorsos::WinAttr
	addq.l		#6,sp
;Draw title string
	pea		title2(pc)		;*String
	move.w		#0,-(sp)		;Y
	move.w		#7,-(sp)		;X
	move.l		#win2,-(sp)		;*Window
	jsr		doorsos::WinStrXY
	add.w		#12,sp


	move.w		#%0000000000000001,-(sp)
	move.w		#80,-(sp)
	move.w		#30,-(sp)
	move.w		#40,-(sp)
	move.w		#35,-(sp)
	move.w		#45,-(sp)
	move.w		#4,-(sp)
	move.l		#win2,-(sp)
	jsr		doorsos::WinFillTriangle
	add.w		#18,sp

;If not specified: filled, black
;0000: Filled, white
;0002: XOR?
;0007: Edge lines 2x thick
;0008: Vertical shading
;0009: Horizontal shading
;000A: Diagonal shading, right
;000B: Diagonal shading, left

	move.w		#$0070,-(sp)
	move.w		#70,-(sp)
	move.w		#40,-(sp)
	move.w		#50,-(sp)
	move.w		#38,-(sp)
	move.w		#55,-(sp)
	move.w		#9,-(sp)
	move.l		#win2,-(sp)
	jsr		doorsos::WinFillTriangle
	add.w		#18,sp



;Set window font
	move.w		#F_LARGE,-(sp)
	move.l		#win2,-(sp)
	jsr		doorsos::WinFont
	add.w		#6,sp
;Set window attributes
	move.w		#A_REVERSE,-(sp)
	move.l		#win2,-(sp)
	jsr		doorsos::WinAttr
	addq.l		#6,sp
;Draw test string
	pea		string(pc)		;*String
	move.w		#30,-(sp)		;Y
	move.w		#-13,-(sp)		;X
	move.l		#win2,-(sp)		;*Window
	jsr		doorsos::WinStrXY
	add.w		#12,sp

	jsr		userlib::idle_loop

	move.l		#win1,-(sp)
	jsr		doorsos::WinActivate
	jsr		doorsos::WinBackupToScr
	addq.l		#4,sp

	jsr		userlib::idle_loop

	move.l		#win2,-(sp)
	jsr		doorsos::WinActivate
	jsr		doorsos::WinBackupToScr
	addq.l		#4,sp

	jsr		userlib::idle_loop

	move.l		#win1,-(sp)
	jsr		doorsos::WinClose
	move.l		#win2,(sp)
	jsr		doorsos::WinClose
	addq.l		#4,sp

_exit:
	rts

;***********************************************************************


;***********************************************************************

	EVEN
title1	dc.b	"Test window",0
title2	dc.b	"Window2",0

string	dc.b	"Hello, world!",0

dim1	dc.w	10,10,175,96
dim2	dc.w	50,5,100,120
dim22	dc.w	60,8,150,70

box1	dc.w	0,0,175,5
box2	dc.w	0,0,100,5

line	dc.w	1,1+5,238,126+5
clip	dc.b	35,0,211,107
lclip	dc.b	35,0,111,107

;***********************************************************************

_comment
	dc.b	"TI Window test",0

	BSS

win1	ds.b	42
win2	ds.b	42

	END
